#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stddef.h>
#include <string.h>
#include <unistd.h>
#include <pthread.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <errno.h>
#include <signal.h>
#include "aiot_state_api.h"
#include "aiot_sysdep_api.h"
#include <xquic/xquic.h>

#include <stdio.h>
#include <event2/event.h>
#include <memory.h>
#include <errno.h>
#include <signal.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <inttypes.h>
#include <xquic/xquic.h>
#include <xquic/xquic_typedef.h>
#include <semaphore.h>

#define RING_BUFFER_SIZE            (10*2048)
#define XQC_PACKET_TMP_BUF_LEN 1500
#define XQC_ALPN_TRANSPORT "mqtt"
#define WAIT_INTERVAL (1000)

typedef struct {
    uint8_t  data[RING_BUFFER_SIZE];
    uint16_t tail;  //待读取的数据，还没有读取
    uint16_t head;  //待写入的数据，还没写入
} ring_buffer_t;
#define XQC_MAX_LOG_LEN 2048


static ring_buffer_t   g_rx_buf = {0};

int get_last_sys_errno()
{
    int err = 0;
#ifdef XQC_SYS_WINDOWS
    err = WSAGetLastError();
#else
    err = errno;
#endif
    return err;
}

static pthread_t g_quic_connection_thread;
int g_pre_quic_loop_running = 0;

typedef struct user_conn_s {
    int                 fd;
    xqc_cid_t           cid;

    struct sockaddr    *local_addr;
    socklen_t           local_addrlen;
    xqc_flag_t          get_local_addr;
    struct sockaddr    *peer_addr;
    socklen_t           peer_addrlen;

    unsigned char      *token;
    unsigned            token_len;

    struct event       *ev_socket;
    struct event       *ev_timeout;

    int                 h3;

    int                 rebinding_fd;
    struct event       *rebinding_ev_socket;
    struct event_base  *eb_alias;
    sem_t *conn_sem_alias;
} user_conn_t;

static uint64_t last_recv_ts = 0;


typedef struct user_stream_s {
    xqc_stream_t       *stream;
    xqc_h3_request_t   *h3_request;
    user_conn_t        *user_conn;
    uint64_t            send_offset;
    int                 header_sent;
    int                 header_recvd;
    char               *send_body;
    size_t              send_body_len;
    size_t              send_body_max;
    char               *recv_body;
    size_t              recv_body_len;
    FILE               *recv_body_fp;
    int                 recv_fin;
    xqc_msec_t          start_time;
    xqc_msec_t          first_frame_time;   /* first frame download time */
    xqc_msec_t          last_read_time;
    int                 abnormal_count;
    int                 body_read_notify_cnt;
} user_stream_t;

typedef struct client_ctx_s {
    xqc_engine_t   *engine;
    struct event   *ev_engine;
    int             log_fd;
    int             keylog_fd;
    struct event   *ev_delay;
} client_ctx_t;

client_ctx_t ctx;
xqc_cong_ctrl_callback_t cong_ctrl;
int g_req_cnt;
int g_req_max;
int g_send_body_size;
int g_save_body;
int g_drop_rate;
int g_ping_id = 1;
int g_spec_url;
uint64_t g_last_sock_op_time;
//currently, the maximum used test case id is 19
//please keep this comment updated if you are adding more test cases. :-D
uint32_t cong_flags = 0;
int g_ipv6;
int g_no_crypt;
int hsk_completed = 0;
char g_log_path[256];
int g_conn_timeout = 1;
int g_connected = 0;

/* socket建联时间默认最大值 */
#define CORE_SYSDEP_DEFAULT_CONNECT_TIMEOUT_MS (10 * 1000)

typedef struct {
    int fd;
    core_sysdep_socket_type_t socket_type;
    char *host;
    char backup_ip[16];
    uint16_t port;
    uint32_t connect_timeout_ms;
    struct event_base *eb;
    user_conn_t *user_conn;
    sem_t *conn_sem;
    void *stream;
} core_network_handle_t;

void *core_sysdep_malloc(uint32_t size, char *name)
{
    return malloc(size);
}

void core_sysdep_free(void *ptr)
{
    free(ptr);
}

uint64_t core_sysdep_time(void)
{
    struct timeval time;

    memset(&time, 0, sizeof(struct timeval));
    gettimeofday(&time, NULL);

    return ((uint64_t)time.tv_sec * 1000 + (uint64_t)time.tv_usec / 1000);
}

void core_sysdep_sleep(uint64_t time_ms)
{
    usleep(time_ms * 1000);
}

void
xqc_client_set_event_timer(xqc_msec_t wake_after, void *user_data)
{
    client_ctx_t *ctx = (client_ctx_t *) user_data;
#ifdef DEBUG_LOG
    printf("xqc_engine_wakeup_after %llu us, now %llu\n", wake_after, xqc_now());
#endif
    // printf("xqc_engine_wakeup_after %llu us\n", wake_after);

    struct timeval tv;
    tv.tv_sec = wake_after / 1000000;
    tv.tv_usec = wake_after % 1000000;
    event_add(ctx->ev_engine, &tv);

}


void set_last_sys_errno(int err)
{
#ifdef XQC_SYS_WINDOWS
    WSASetLastError(err);
#else
    errno = err;
#endif
}

void
xqc_convert_addr_text_to_sockaddr(int type,
                                  const char *addr_text, unsigned int port,
                                  struct sockaddr **saddr, socklen_t *saddr_len)
{
    if (type == AF_INET6) {
        *saddr = calloc(1, sizeof(struct sockaddr_in6));
        memset(*saddr, 0, sizeof(struct sockaddr_in6));
        struct sockaddr_in6 *addr_v6 = (struct sockaddr_in6 *)(*saddr);
        inet_pton(type, addr_text, &(addr_v6->sin6_addr.s6_addr));
        addr_v6->sin6_family = type;
        addr_v6->sin6_port = htons(port);
        *saddr_len = sizeof(struct sockaddr_in6);

    } else {
        *saddr = calloc(1, sizeof(struct sockaddr_in));
        memset(*saddr, 0, sizeof(struct sockaddr_in));
        struct sockaddr_in *addr_v4 = (struct sockaddr_in *)(*saddr);
        inet_pton(type, addr_text, &(addr_v4->sin_addr.s_addr));
        addr_v4->sin_family = type;
        addr_v4->sin_port = htons(port);
        *saddr_len = sizeof(struct sockaddr_in);
    }
}

static void
xqc_client_timeout_callback(int fd, short what, void *arg)
{
    //printf("xqc_client_timeout_callback now %"PRIu64"\n", xqc_now());
    user_conn_t *user_conn = (user_conn_t *) arg;
    int rc;
    static int restart_after_a_while = 1;

    if (xqc_now() - g_last_sock_op_time < (uint64_t)g_conn_timeout * 1000000) {
        struct timeval tv;
        tv.tv_sec = g_conn_timeout;
        tv.tv_usec = 0;
        event_add(user_conn->ev_timeout, &tv);
        return;
    }

    if (1 == g_connected && xqc_now() - g_last_sock_op_time < (uint64_t)90 * 1000000) {
        struct timeval tv;
        tv.tv_sec = g_conn_timeout;
        tv.tv_usec = 0;
        event_add(user_conn->ev_timeout, &tv);
        return;
    }

conn_close:
    rc = xqc_conn_close(ctx.engine, &user_conn->cid);
    if (rc) {
        printf("xqc_conn_close error\n");
        return;
    }
    //event_base_loopbreak(eb);
}

static int
xqc_client_create_socket(int type,
                         const struct sockaddr *saddr, socklen_t saddr_len)
{
    int size;
    int fd = -1;
    int flags;

    /* create fd & set socket option */
    fd = socket(type, SOCK_DGRAM, 0);
    if (fd < 0) {
        printf("create socket failed, errno: %d\n", get_last_sys_errno());
        return -1;
    }

#ifdef XQC_SYS_WINDOWS
    if (ioctlsocket(fd, FIONBIO, &flags) == SOCKET_ERROR) {
        goto err;
    }
#else
    if (fcntl(fd, F_SETFL, O_NONBLOCK) == -1) {
        printf("set socket nonblock failed, errno: %d\n", get_last_sys_errno());
        goto err;
    }
#endif

    size = 1 * 1024 * 1024;
    if (setsockopt(fd, SOL_SOCKET, SO_RCVBUF, &size, sizeof(int)) < 0) {
        printf("setsockopt failed, errno: %d\n", get_last_sys_errno());
        goto err;
    }

    if (setsockopt(fd, SOL_SOCKET, SO_SNDBUF, &size, sizeof(int)) < 0) {
        printf("setsockopt failed, errno: %d\n", get_last_sys_errno());
        goto err;
    }

    g_last_sock_op_time = xqc_now();

    /* connect to peer addr */
#if !defined(__APPLE__)
    if (connect(fd, (struct sockaddr *)saddr, saddr_len) < 0) {
        printf("connect socket failed, errno: %d\n", get_last_sys_errno());
        goto err;
    }
#endif

    return fd;

err:
    close(fd);
    return -1;
}

void
xqc_client_init_addr(user_conn_t *user_conn,
                     const char *server_addr, int server_port)
{
    int ip_type = (g_ipv6 ? AF_INET6 : AF_INET);
    xqc_convert_addr_text_to_sockaddr(ip_type,
                                      server_addr, server_port,
                                      &user_conn->peer_addr,
                                      &user_conn->peer_addrlen);

    if (ip_type == AF_INET6) {
        user_conn->local_addr = (struct sockaddr *)calloc(1, sizeof(struct sockaddr_in6));
        memset(user_conn->local_addr, 0, sizeof(struct sockaddr_in6));
        user_conn->local_addrlen = sizeof(struct sockaddr_in6);

    } else {
        user_conn->local_addr = (struct sockaddr *)calloc(1, sizeof(struct sockaddr_in));
        memset(user_conn->local_addr, 0, sizeof(struct sockaddr_in));
        user_conn->local_addrlen = sizeof(struct sockaddr_in);
    }
}

void
xqc_client_socket_write_handler(user_conn_t *user_conn)
{
    xqc_conn_continue_send(ctx.engine, &user_conn->cid);
}

void
xqc_client_socket_read_handler(user_conn_t *user_conn, int fd)
{
    //DEBUG;

    ssize_t recv_size = 0;
    ssize_t recv_sum = 0;

    unsigned char packet_buf[XQC_PACKET_TMP_BUF_LEN];

    static ssize_t last_rcv_sum = 0;
    static ssize_t rcv_sum = 0;

    do {
        recv_size = recvfrom(fd,
                             packet_buf, sizeof(packet_buf), 0,
                             user_conn->peer_addr, &user_conn->peer_addrlen);
        if (recv_size < 0 && get_last_sys_errno() == EAGAIN) {
            break;
        }

        if (recv_size < 0) {
            printf("recvfrom: recvmsg = %zd(%s)\n", recv_size, strerror(get_last_sys_errno()));
            break;
        }

        /* if recv_size is 0, break while loop, */
        if (recv_size == 0) {
            break;
        }
        recv_sum += recv_size;
        rcv_sum += recv_size;

        if (user_conn->get_local_addr == 0) {
            user_conn->get_local_addr = 1;
            socklen_t tmp = sizeof(struct sockaddr_in6);
            int ret = getsockname(user_conn->fd, (struct sockaddr *) user_conn->local_addr, &tmp);
            if (ret < 0) {
                printf("getsockname error, errno: %d\n", get_last_sys_errno());
                break;
            }
            user_conn->local_addrlen = tmp;
        }

        uint64_t recv_time = xqc_now();
        g_last_sock_op_time = recv_time;

        static char copy[XQC_PACKET_TMP_BUF_LEN];

        if (xqc_engine_packet_process(ctx.engine, packet_buf, recv_size,
                                      user_conn->local_addr, user_conn->local_addrlen,
                                      user_conn->peer_addr, user_conn->peer_addrlen,
                                      (xqc_msec_t)recv_time, user_conn) != XQC_OK) {
            printf("xqc_client_read_handler: packet process err\n");
            return;
        }

    } while (recv_size > 0);

    if ((xqc_now() - last_recv_ts) > 200000) {
        printf("recving rate: %.3lf Kbps\n", (rcv_sum - last_rcv_sum) * 8.0 * 1000 / (xqc_now() - last_recv_ts));
        last_recv_ts = xqc_now();
        last_rcv_sum = rcv_sum;
    }

finish_recv:
    printf("recvfrom size:%zu\n", recv_sum);
    xqc_engine_finish_recv(ctx.engine);
}

static void
xqc_client_socket_event_callback(int fd, short what, void *arg)
{
    //DEBUG;
    user_conn_t *user_conn = (user_conn_t *) arg;

    if (what & EV_WRITE) {
        xqc_client_socket_write_handler(user_conn);

    } else if (what & EV_READ) {
        xqc_client_socket_read_handler(user_conn, fd);

    } else {
        printf("event callback: what=%d\n", what);
        exit(1);
    }
}

int
xqc_client_open_keylog_file(client_ctx_t *ctx)
{
    ctx->keylog_fd = open("./ckeys.log", (O_WRONLY | O_APPEND | O_CREAT), 0644);
    if (ctx->keylog_fd <= 0) {
        printf("open ckeys failed\r\n");
        return -1;
    }

    return 0;
}

void
xqc_keylog_cb(const char *line, void *user_data)
{
    client_ctx_t *ctx = (client_ctx_t *)user_data;
    if (ctx->keylog_fd <= 0) {
        printf("write keys error!\n");
        return;
    }

    int write_len = write(ctx->keylog_fd, line, strlen(line));
    if (write_len < 0) {
        printf("write keys failed, errno: %d\n", get_last_sys_errno());
        return;
    }

    write_len = write(ctx->keylog_fd, "\n", 1);
    if (write_len < 0) {
        printf("write keys failed, errno: %d\n", get_last_sys_errno());
    }
}

ssize_t
xqc_client_write_socket(const unsigned char *buf, size_t size,
                        const struct sockaddr *peer_addr, socklen_t peer_addrlen, void *user)
{
    user_conn_t *user_conn = (user_conn_t *) user;
    ssize_t res = 0;
    int fd = user_conn->fd;

    /* COPY to run corruption test cases */
    unsigned char send_buf[XQC_PACKET_TMP_BUF_LEN];
    size_t send_buf_size = 0;

    if (size > XQC_PACKET_TMP_BUF_LEN) {
        printf("xqc_client_write_socket err: size=%zu is too long\n", size);
        return XQC_SOCKET_ERROR;
    }
    send_buf_size = size;
    memcpy(send_buf, buf, send_buf_size);

    do {
        set_last_sys_errno(0);

        g_last_sock_op_time = xqc_now();

        res = sendto(fd, send_buf, send_buf_size, 0, peer_addr, peer_addrlen);
        if (res < 0) {
            printf("xqc_client_write_socket err %zd %s\n", res, strerror(get_last_sys_errno()));
            if (get_last_sys_errno() == EAGAIN) {
                res = XQC_SOCKET_EAGAIN;
            }
        }
    } while ((res < 0) && (get_last_sys_errno() == EINTR));

    return res;
}


void
xqc_client_save_token(const unsigned char *token, unsigned token_len, void *user_data)
{
    user_conn_t *user_conn = (user_conn_t *)user_data;
    printf("xqc_client_save_token use client ip as the key. h3[%d]\n", user_conn->h3);

    int fd = open("./xqc_token", O_TRUNC | O_CREAT | O_WRONLY, 0666);
    if (fd < 0) {
        printf("save token error %s\n", strerror(get_last_sys_errno()));
        return;
    }

    ssize_t n = write(fd, token, token_len);
    if (n < token_len) {
        printf("save token error %s\n", strerror(get_last_sys_errno()));
        close(fd);
        return;
    }
    close(fd);
}

int
xqc_client_cert_verify(const unsigned char *certs[],
                       const size_t cert_len[], size_t certs_len, void *conn_user_data)
{
    /* self-signed cert used in test cases, return >= 0 means success */
    return 0;
}

void
xqc_client_write_log(xqc_log_level_t lvl, const void *buf, size_t count, void *engine_user_data)
{
    unsigned char log_buf[XQC_MAX_LOG_LEN + 1];

    client_ctx_t *ctx = (client_ctx_t *)engine_user_data;
    if (ctx->log_fd <= 0) {
        printf("xqc_client_write_log fd err\n");
        return;
    }

    int log_len = snprintf(log_buf, XQC_MAX_LOG_LEN + 1, "%s\n", (char *)buf);
    if (log_len < 0) {
        printf("xqc_client_write_log err\n");
        return;
    }

    int write_len = write(ctx->log_fd, log_buf, log_len);
    if (write_len < 0) {
        printf("write log failed, errno: %d\n", get_last_sys_errno());
    }
}
void
save_tp_cb(const char *data, size_t data_len, void *user_data)
{
    user_conn_t *user_conn = (user_conn_t *)user_data;
    printf("save_tp_cb use server domain as the key. h3[%d]\n", user_conn->h3);

    FILE *fp = fopen("tp_localhost", "wb");
    int write_size = fwrite(data, 1, data_len, fp);
    if (data_len != write_size) {
        printf("save _tp_cb error\n");
        fclose(fp);
        return;
    }
    fclose(fp);
    return;
}

xqc_int_t
xqc_client_conn_closing_notify(xqc_connection_t *conn,
                               const xqc_cid_t *cid, xqc_int_t err_code, void *conn_user_data)
{
    printf("------conn closing: %d\n", err_code);
    return XQC_OK;
}

void
xqc_client_conn_handshake_finished(xqc_connection_t *conn, void *user_data, void *conn_proto_data)
{
    //DEBUG;
    user_conn_t *user_conn = (user_conn_t *) user_data;
    xqc_conn_send_ping(ctx.engine, &user_conn->cid, NULL);
    xqc_conn_send_ping(ctx.engine, &user_conn->cid, &g_ping_id);

    g_connected = 1;

    printf("====>DCID:%s\n", xqc_dcid_str_by_scid(ctx.engine, &user_conn->cid));
    printf("====>SCID:%s\n", xqc_scid_str(&user_conn->cid));
    sem_post(user_conn->conn_sem_alias);

    hsk_completed = 1;
}


void
save_session_cb(const char *data, size_t data_len, void *user_data)
{
    user_conn_t *user_conn = (user_conn_t *)user_data;
    printf("save_session_cb use server domain as the key. h3[%d]\n", user_conn->h3);

    FILE *fp  = fopen("test_session", "wb");
    int write_size = fwrite(data, 1, data_len, fp);
    if (data_len != write_size) {
        printf("save _session_cb error\n");
        fclose(fp);
        return;
    }
    fclose(fp);
    return;
}

static void
xqc_client_engine_callback(int fd, short what, void *arg)
{
#ifdef DEBUG_LOG
    printf("timer wakeup now:%"PRIu64"\n", xqc_now());
#endif
    client_ctx_t *ctx = (client_ctx_t *) arg;

    xqc_engine_main_logic(ctx->engine);
}

int
xqc_client_conn_create_notify(xqc_connection_t *conn, const xqc_cid_t *cid, void *user_data, void *conn_proto_data)
{

    user_conn_t *user_conn = (user_conn_t *)user_data;
    xqc_conn_set_alp_user_data(conn, user_conn);

    printf("xqc_conn_is_ready_to_send_early_data:%d\n", xqc_conn_is_ready_to_send_early_data(conn));
    return 0;
}

int
xqc_client_conn_close_notify(xqc_connection_t *conn, const xqc_cid_t *cid, void *user_data, void *conn_proto_data)
{
    user_conn_t *user_conn = (user_conn_t *)conn_proto_data;

    xqc_conn_stats_t stats = xqc_conn_get_stats(ctx.engine, cid);
    printf("send_count:%u, lost_count:%u, tlp_count:%u, recv_count:%u, srtt:%"PRIu64" early_data_flag:%d, conn_err:%d, ack_info:%s\n",
           stats.send_count, stats.lost_count, stats.tlp_count, stats.recv_count, stats.srtt, stats.early_data_flag,
           stats.conn_err, stats.ack_info);
    g_connected = 0;

    event_base_loopbreak(user_conn->eb_alias);
    return 0;
}

void
xqc_client_conn_ping_acked_notify(xqc_connection_t *conn, const xqc_cid_t *cid, void *ping_user_data, void *user_data,
                                  void *conn_proto_data)
{
    if (ping_user_data) {
        printf("====>ping_id:%d\n", *(int *) ping_user_data);

    } else {
        printf("====>no ping_id\n");
    }
}

int
xqc_client_stream_write_notify(xqc_stream_t *stream, void *user_data)
{
    int ret = 0;
    user_stream_t *user_stream = (user_stream_t *) user_data;
    //ret = xqc_client_stream_send(stream, user_stream);
    return ret;
}

int
xqc_client_stream_read_notify(xqc_stream_t *stream, void *user_data)
{
    unsigned char fin = 0;
    user_stream_t *user_stream = (user_stream_t *) user_data;
    uint8_t *g_buff = NULL;
    int read = 0;

    //todo ring buffer overflow. But there is no solution for buffer overflow case
    do {
        if (g_rx_buf.head == RING_BUFFER_SIZE - 1) {
            g_rx_buf.head = 0;
        }

        g_buff = &(g_rx_buf.data[0]) + g_rx_buf.head;
        uint64_t remain_size = RING_BUFFER_SIZE - 1 - g_rx_buf.head;
        read =  xqc_stream_recv(stream, g_buff, remain_size, &fin);
        if (read > 0) {
            g_rx_buf.head += read;
        }
#ifdef DEBUG_LOG
        printf("ringBufferDebug:after read now head is %d, tail is %d, got %d bytes, \r\n", g_rx_buf.head, g_rx_buf.tail, read);
#endif


        if (g_rx_buf.head >= RING_BUFFER_SIZE) {
#ifdef DEBUG_LOG
            printf("ringBufferDebug: over run head is %d, fin is %d\r\n", g_rx_buf.head, fin);
#endif
        }
    } while (read > 0 && !fin);

#ifdef DEBUG_LOG
    printf("ringBufferDebug: after read now head is %d, tail is %d, \r\n", g_rx_buf.head, g_rx_buf.tail);
#endif
    return 0;
}

int
xqc_client_open_log_file(void *engine_user_data)
{
    client_ctx_t *ctx = (client_ctx_t *)engine_user_data;
    //ctx->log_fd = open("/home/jiuhai.zjh/ramdisk/clog", (O_WRONLY | O_APPEND | O_CREAT), 0644);
    ctx->log_fd = open(g_log_path, (O_WRONLY | O_APPEND | O_CREAT), 0644);
    if (ctx->log_fd <= 0) {
        return -1;
    }
    return 0;
}

int
xqc_client_close_log_file(void *engine_user_data)
{
    client_ctx_t *ctx = (client_ctx_t *)engine_user_data;
    if (ctx->log_fd <= 0) {
        return -1;
    }
    close(ctx->log_fd);
    return 0;
}

int
xqc_client_stream_close_notify(xqc_stream_t *stream, void *user_data)
{
    user_stream_t *user_stream = (user_stream_t *)user_data;

    free(user_stream->send_body);
    free(user_stream->recv_body);
    free(user_stream);
    return 0;
}

user_conn_t *
xqc_client_user_conn_create(const char *server_addr, int server_port,
                            int transport, struct event_base  *eb)
{
    user_conn_t *user_conn = calloc(1, sizeof(user_conn_t));

    /* use HTTP3? */
    user_conn->h3 = transport ? 0 : 1;
    user_conn->eb_alias = eb;

    user_conn->ev_timeout = event_new(eb, -1, 0, xqc_client_timeout_callback, user_conn);
    /* set connection timeout */
    struct timeval tv;
    tv.tv_sec = g_conn_timeout;
    tv.tv_usec = 0;
    event_add(user_conn->ev_timeout, &tv);

    int ip_type = (g_ipv6 ? AF_INET6 : AF_INET);
    xqc_client_init_addr(user_conn, server_addr, server_port);

    user_conn->fd = xqc_client_create_socket(ip_type,
                    user_conn->peer_addr, user_conn->peer_addrlen);
    if (user_conn->fd < 0) {
        printf("xqc_create_socket error\n");
        return NULL;
    }

    user_conn->ev_socket = event_new(eb, user_conn->fd, EV_READ | EV_PERSIST,
                                     xqc_client_socket_event_callback, user_conn);
    event_add(user_conn->ev_socket, NULL);


    user_conn->rebinding_fd = xqc_client_create_socket(ip_type,
                              user_conn->peer_addr, user_conn->peer_addrlen);
    if (user_conn->rebinding_fd < 0) {
        printf("|rebinding|xqc_create_socket error\n");
        return NULL;
    }

    user_conn->rebinding_ev_socket = event_new(eb, user_conn->rebinding_fd, EV_READ | EV_PERSIST,
                                     xqc_client_socket_event_callback, user_conn);
    event_add(user_conn->rebinding_ev_socket, NULL);

    return user_conn;
}


static void *core_sysdep_network_init(void)
{
    printf("doing network init\r\n");

    core_network_handle_t *handle = malloc(sizeof(core_network_handle_t));
    if (handle == NULL) {
        return NULL;
    }
    memset(&g_rx_buf, 0, sizeof(g_rx_buf));
    memset(handle, 0, sizeof(core_network_handle_t));
    handle->fd = -1;
    handle->connect_timeout_ms = CORE_SYSDEP_DEFAULT_CONNECT_TIMEOUT_MS;


    g_req_cnt = 0;
    g_req_max = 1;
    g_send_body_size = 1024 * 1024;
    g_save_body = 0;
    g_drop_rate = 0;
    g_spec_url = 0;
    g_ipv6 = 0;
    g_no_crypt = 0;

    char c_cong_ctl = 'b';
    char c_log_level = 'd';
    int c_cong_plus = 0;
    int transport = 0;
    int use_1rtt = 0;
    strcpy(g_log_path, "./clog");

    memset(&ctx, 0, sizeof(ctx));

    xqc_client_open_keylog_file(&ctx);
    xqc_client_open_log_file(&ctx);

    //xqc_platform_init_env();

    xqc_engine_ssl_config_t  engine_ssl_config;
    memset(&engine_ssl_config, 0, sizeof(engine_ssl_config));
    /* client does not need to fill in private_key_file & cert_file */
    engine_ssl_config.ciphers = XQC_TLS_CIPHERS;
    engine_ssl_config.groups = XQC_TLS_GROUPS;

    xqc_engine_callback_t callback = {
        .set_event_timer = xqc_client_set_event_timer, /* call xqc_engine_main_logic when the timer expires */
        .log_callbacks = {
            .xqc_log_write_err = xqc_client_write_log,
            .xqc_log_write_stat = xqc_client_write_log,
        },
        .keylog_cb = xqc_keylog_cb,
    };

    xqc_transport_callbacks_t tcbs = {
        .write_socket = xqc_client_write_socket,
        .save_token = xqc_client_save_token,
        .save_session_cb = save_session_cb,
        .save_tp_cb = save_tp_cb,
        .cert_verify_cb = xqc_client_cert_verify,
        .conn_closing = xqc_client_conn_closing_notify,
    };

    if (c_cong_ctl == 'b') {
        cong_ctrl = xqc_bbr_cb;
        cong_flags = XQC_BBR_FLAG_NONE;
#if XQC_BBR_RTTVAR_COMPENSATION_ENABLED
        if (c_cong_plus) {
            cong_flags |= XQC_BBR_FLAG_RTTVAR_COMPENSATION;
        }
#endif
    }
#ifndef XQC_DISABLE_RENO
    else if (c_cong_ctl == 'r') {
        cong_ctrl = xqc_reno_cb;
    }
#endif
    else if (c_cong_ctl == 'c') {
        cong_ctrl = xqc_cubic_cb;
    }
#ifdef XQC_ENABLE_BBR2
    else if (c_cong_ctl == 'B') {
        cong_ctrl = xqc_bbr2_cb;
        cong_flags = XQC_BBR2_FLAG_NONE;
#if XQC_BBR2_PLUS_ENABLED
        if (c_cong_plus) {
            cong_flags |= XQC_BBR2_FLAG_RTTVAR_COMPENSATION;
            cong_flags |= XQC_BBR2_FLAG_FAST_CONVERGENCE;
        }
#endif
    }
#endif
    else {
        printf("unknown cong_ctrl, option is b, r, c, B, bbr+, bbr2+\n");
        return NULL;
    }
    printf("congestion control flags: %x\n", cong_flags);

    xqc_config_t config;
    if (xqc_engine_get_default_config(&config, XQC_ENGINE_CLIENT) < 0) {
        printf(" return without err info \r\n");
        return NULL;
    }
    config.cfg_log_level = c_log_level == 'e' ? XQC_LOG_ERROR : (c_log_level == 'i' ? XQC_LOG_INFO : c_log_level == 'w' ?
                           XQC_LOG_STATS : XQC_LOG_DEBUG);

    handle->eb = event_base_new();
    g_pre_quic_loop_running = 1;

    ctx.ev_engine = event_new(handle->eb, -1, 0, xqc_client_engine_callback, &ctx);

    ctx.engine = xqc_engine_create(XQC_ENGINE_CLIENT, &config, &engine_ssl_config,
                                   &callback, &tcbs, &ctx);
    if (ctx.engine == NULL) {
        printf("xqc_engine_create error\n");
        return NULL;
    }

    /* register transport callbacks */
    xqc_app_proto_callbacks_t ap_cbs = {
        .conn_cbs = {
            .conn_create_notify = xqc_client_conn_create_notify,
            .conn_close_notify = xqc_client_conn_close_notify,
            .conn_handshake_finished = xqc_client_conn_handshake_finished,
            .conn_ping_acked = xqc_client_conn_ping_acked_notify,
        },
        .stream_cbs = {
            .stream_write_notify = xqc_client_stream_write_notify,
            .stream_read_notify = xqc_client_stream_read_notify,
            .stream_close_notify = xqc_client_stream_close_notify,
        }
    };

    xqc_engine_register_alpn(ctx.engine, XQC_ALPN_TRANSPORT, strlen(XQC_ALPN_TRANSPORT), &ap_cbs);

    printf("engine created done\r\n");
    return handle;
}

static int32_t core_sysdep_network_setopt(void *handle, core_sysdep_network_option_t option, void *data)
{
    core_network_handle_t *network_handle = (core_network_handle_t *)handle;

    if (handle == NULL || data == NULL) {
        return STATE_PORT_INPUT_NULL_POINTER;
    }

    if (option >= CORE_SYSDEP_NETWORK_MAX) {
        return STATE_PORT_INPUT_OUT_RANGE;
    }

    switch (option) {
        case CORE_SYSDEP_NETWORK_SOCKET_TYPE: {
            network_handle->socket_type = *(core_sysdep_socket_type_t *)data;
        }
        break;
        case CORE_SYSDEP_NETWORK_HOST: {
            network_handle->host = malloc(strlen(data) + 1);
            if (network_handle->host == NULL) {
                printf("malloc failed\n");
                return STATE_PORT_MALLOC_FAILED;
            }
            memset(network_handle->host, 0, strlen(data) + 1);
            memcpy(network_handle->host, data, strlen(data));
        }
        break;
        case CORE_SYSDEP_NETWORK_BACKUP_IP: {
            memcpy(network_handle->backup_ip, data, strlen(data));
        }
        break;
        case CORE_SYSDEP_NETWORK_PORT: {
            network_handle->port = *(uint16_t *)data;
        }
        break;
        case CORE_SYSDEP_NETWORK_CONNECT_TIMEOUT_MS: {
            network_handle->connect_timeout_ms = *(uint32_t *)data;
        }
        break;
        default: {
            break;
        }
    }

    return STATE_SUCCESS;
}

static void _port_uint2str(uint16_t input, char *output)
{
    uint8_t i = 0, j = 0;
    char temp[6] = {0};

    do {
        temp[i++] = input % 10 + '0';
    } while ((input /= 10) > 0);

    do {
        output[--i] = temp[j++];
    } while (i > 0);
}


static int32_t _core_sysdep_network_udp_server_establish(core_network_handle_t *network_handle)
{
    return 0;
}

int
xqc_client_close_keylog_file(client_ctx_t *ctx)
{
    if (ctx->keylog_fd <= 0) {
        return -1;
    }

    close(ctx->keylog_fd);
    ctx->keylog_fd = 0;
    return 0;
}


void *quic_connection_thread(void *args)
{
    core_network_handle_t *network_handle = (core_network_handle_t *)args;
    printf("try to start mqtt process thread\r\n");
    if (NULL == network_handle) {
        return NULL;
    }

    int transport = 1;
    printf("now host is %s\r\n", network_handle->host);
    struct addrinfo hints, *addr_list, *cur;
    int ret;

    memset(&hints, 0, sizeof(hints));
    hints.ai_family = AF_UNSPEC;
    hints.ai_socktype = SOCK_DGRAM;
    hints.ai_protocol = IPPROTO_UDP;

    char port_str[10];
    memset(port_str, 0, 10);
    snprintf(port_str, 10, "%d", network_handle->port);

    ret = getaddrinfo(network_handle->host, port_str, &hints, &addr_list);

    for (cur = addr_list; cur != NULL; cur = cur->ai_next) {
        char ip4_str[INET_ADDRSTRLEN];
        inet_ntop(AF_INET, &((const struct sockaddr_in *)cur->ai_addr)->sin_addr, ip4_str, INET_ADDRSTRLEN);
        printf("now ipv4 is %s\r\n", ip4_str);

        user_conn_t *user_conn = xqc_client_user_conn_create(ip4_str, network_handle->port, transport,
                                 network_handle->eb);

        if (user_conn == NULL) {
            printf("xqc_client_user_conn_create error\n");
            break;
        }
        user_conn->conn_sem_alias = network_handle->conn_sem;
        network_handle->user_conn = user_conn;

        xqc_conn_ssl_config_t conn_ssl_config;
        memset(&conn_ssl_config, 0, sizeof(conn_ssl_config));
        conn_ssl_config.cert_verify_flag |= XQC_TLS_CERT_FLAG_NEED_VERIFY;

        int pacing_on = 0;

        xqc_conn_settings_t conn_settings = {
            .pacing_on  =   pacing_on,
            .ping_on    =   0,
            .cong_ctrl_callback = cong_ctrl,
            .cc_params  =   {.customize_on = 1, .init_cwnd = 32, .cc_optimization_flags = cong_flags},
            //.so_sndbuf  =   1024*1024,
            .proto_version = XQC_VERSION_V1,
            .spurious_loss_detect_on = 0,
            .keyupdate_pkt_threshold = 0,
        };

        printf("sessoin data read error or use_1rtt\n");
        conn_ssl_config.session_ticket_data = NULL;
        conn_ssl_config.transport_parameter_data = NULL;

        const xqc_cid_t *cid;
        user_conn->h3 = 0;

        {
            cid = xqc_connect(ctx.engine, &conn_settings, user_conn->token, user_conn->token_len,
                              network_handle->host, g_no_crypt, &conn_ssl_config, user_conn->peer_addr,
                              user_conn->peer_addrlen, XQC_ALPN_TRANSPORT, user_conn);
        }

        if (cid == NULL) {
            printf("xqc_connect error\n");
            xqc_engine_destroy(ctx.engine);
            break;
        }

        /* copy cid to its own memory space to prevent crashes caused by internal cid being freed */
        memcpy(&user_conn->cid, cid, sizeof(*cid));

        g_req_cnt++;
        user_stream_t *user_stream = calloc(1, sizeof(user_stream_t));
        user_stream->user_conn = user_conn;
        {
            printf("xqc_stream_create ready to go \n");
            user_stream->stream = xqc_stream_create(ctx.engine, cid, user_stream);
            if (user_stream->stream == NULL) {
                printf("xqc_stream_create error\n");
                break;
            }

            network_handle->stream = user_stream->stream;
        }

        last_recv_ts = xqc_now();
        event_base_dispatch(network_handle->eb);
        event_free(user_conn->ev_socket);
        event_free(user_conn->ev_timeout);
        event_free(user_conn->rebinding_ev_socket);

        free(user_conn->peer_addr);
        free(user_conn->local_addr);
        free(user_conn);

        if (ctx.ev_delay) {
            event_free(ctx.ev_delay);
        }

        xqc_engine_destroy(ctx.engine);
        xqc_client_close_keylog_file(&ctx);
        xqc_client_close_log_file(&ctx);
        sem_post(user_conn->conn_sem_alias);
        g_pre_quic_loop_running = 0;
        printf("close quic loop , exit\r\n");
        break;
    }
    freeaddrinfo(addr_list);
    return NULL;

}

static int32_t core_sysdep_network_establish(void *handle)
{

    core_network_handle_t *network_handle = (core_network_handle_t *)handle;
    network_handle->conn_sem = malloc(sizeof(sem_t));
    memset(network_handle->conn_sem, 0, sizeof(sem_t));
    sem_init(network_handle->conn_sem, 0, 0);

    int res = pthread_create(&g_quic_connection_thread, NULL, quic_connection_thread, handle);
    if (res < 0) {
        printf("pthread_create quic_connection_thread failed: %d\n", res);
        return -1;
    }
    pthread_detach(g_quic_connection_thread);
    sem_wait(network_handle->conn_sem);
    printf("done network establish \r\n");

    return res;
}


static int32_t _core_sysdep_network_recv(core_network_handle_t *network_handle, uint8_t *buffer, uint32_t len,
        uint32_t timeout_ms)
{
    int res = 0;
    int32_t recv_bytes = 0;
    unsigned char fin = 0;
    uint64_t timestart_ms = 0, timenow_ms = 0, timeselect_ms = 0;
    struct timeval timestart, timenow, timeselect;
    ssize_t recv_res = 0;

    gettimeofday(&timestart, NULL);
    timestart_ms = timestart.tv_sec * 1000 + timestart.tv_usec / 1000;
    timenow_ms = timestart_ms;

    do {
        gettimeofday(&timenow, NULL);
        timenow_ms = timenow.tv_sec * 1000 + timenow.tv_usec / 1000;

        if (timenow_ms - timestart_ms >= timenow_ms ||
            timeout_ms - (timenow_ms - timestart_ms) > timeout_ms) {
            printf("timeout exit\r\n");
            break;
        }

        timeselect_ms = timeout_ms - (timenow_ms - timestart_ms);
        timeselect.tv_sec = timeselect_ms / 1000;
        timeselect.tv_usec = timeselect_ms % 1000 * 1000;

        //todo ring buf case
        //1. normal case, head > tail
        //2. turn around case, tail >head
        //3. critical value


        //1. normal case, head > tail
        if (g_rx_buf.head - g_rx_buf.tail >= 0) {

            if (g_rx_buf.head - g_rx_buf.tail < len) {
#ifdef DEBUG_LOG
                printf("not enough data\r\n");
#endif
                usleep(WAIT_INTERVAL);
                continue;
            }

            uint8_t *data_start = &(g_rx_buf.data[0]) + g_rx_buf.tail;
            memcpy(buffer, data_start, len);
            g_rx_buf.tail += len;
            recv_bytes += len;
#ifdef DEBUG_LOG
            printf("now head is %d, tail is %d, len is %d\r\n", g_rx_buf.head, g_rx_buf.tail, len);
#endif
        } else {
            //2. turn around case, tail >head
#if 1
            uint64_t tail2end = RING_BUFFER_SIZE - 1  - g_rx_buf.tail;
            uint8_t *data_start = &(g_rx_buf.data[0]) + g_rx_buf.tail;

            //todo 加上要读的数据，和已有数据长度对比
            if (len <= tail2end) {
                //要读的数据的结尾,在tail和buffer尾部之间,数据够，不用校验长度
                memcpy(buffer, data_start, len);
                g_rx_buf.tail += len;
                recv_bytes += len;
                if (g_rx_buf.tail == RING_BUFFER_SIZE - 1) {
                    g_rx_buf.tail = 0;
                }
#ifdef DEBUG_LOG
                printf("now head is %d, tail is %d, len is %d\r\n", g_rx_buf.head, g_rx_buf.tail, len);
#endif
            } else {
                //3. critical value
                //要读的数据的结尾在buffer头部和head之间
                uint64_t current_data_len = tail2end + g_rx_buf.head - 1 ;
                if (current_data_len < len) {
                    // printf("not enough data in loopback case\r\n");
                    usleep(WAIT_INTERVAL);
                    //sleep(1);
                    continue;
                }

                memcpy(buffer, data_start, tail2end);
                uint64_t remain = len - tail2end;
                uint8_t *new_start = &(g_rx_buf.data[0]);
                memcpy(buffer + tail2end, new_start, remain);
                g_rx_buf.tail = remain ;
                recv_bytes += len;
#ifdef DEBUG_LOG
                printf("now head is %d, tail is %d, len is %d\r\n", g_rx_buf.head, g_rx_buf.tail, len);
#endif
            }
#endif

        }

        break;
    } while (1);

#ifdef DEBUG_LOG
    printf("returned recv_bytes %d\r\n", recv_bytes);
#endif
    return recv_bytes;
}

static int32_t core_sysdep_network_recv(void *handle, uint8_t *buffer, uint32_t len, uint32_t timeout_ms,
                                        core_sysdep_addr_t *addr)
{
    core_network_handle_t *network_handle = (core_network_handle_t *)handle;

    if (handle == NULL || buffer == NULL) {
        return STATE_PORT_INPUT_NULL_POINTER;
    }

    if (len == 0 || timeout_ms == 0) {
        return STATE_PORT_INPUT_OUT_RANGE;
    }

    if (0 == g_connected) {
        printf("hit recv error g_connected < 0 \r\n");
        return -2;
    }

    return _core_sysdep_network_recv(network_handle, buffer, len, timeout_ms);

}


int32_t _core_sysdep_network_send(core_network_handle_t *network_handle, uint8_t *buffer, uint32_t len,
                                  uint32_t timeout_ms)
{

    if (NULL == network_handle || network_handle->stream == NULL) {
        return -1;
    }

    if (0 == g_connected) {
        printf("hit send error g_connected < 0 \r\n");
        return -2;
    }

    int ret = xqc_stream_send(network_handle->stream, buffer, len, 0);

    return ret;
}


static int32_t core_sysdep_network_send(void *handle, uint8_t *buffer, uint32_t len, uint32_t timeout_ms,
                                        core_sysdep_addr_t *addr)
{
    core_network_handle_t *network_handle = (core_network_handle_t *)handle;

    if (handle == NULL || buffer == NULL) {
        printf("invalid parameter\n");
        return STATE_PORT_INPUT_NULL_POINTER;
    }
    if (len == 0 || timeout_ms == 0) {
        return STATE_PORT_INPUT_OUT_RANGE;
    }

    if (network_handle->socket_type == CORE_SYSDEP_SOCKET_TCP_CLIENT) {
        return _core_sysdep_network_send(network_handle, buffer, len, timeout_ms);
    } else if (network_handle->socket_type == CORE_SYSDEP_SOCKET_TCP_SERVER) {
        return STATE_PORT_TCP_SERVER_NOT_IMPLEMENT;
    }

    printf("unknown nwk type\n");
    return STATE_PORT_NETWORK_UNKNOWN_SOCKET_TYPE;
}


static int32_t core_sysdep_network_deinit(void **handle)
{
    core_network_handle_t *network_handle = NULL;

    if (handle == NULL || *handle == NULL) {
        return STATE_PORT_INPUT_NULL_POINTER;
    }

    network_handle = *(core_network_handle_t **)handle;

    if (network_handle->host != NULL) {
        free(network_handle->host);
        network_handle->host = NULL;
    }

    if (NULL == network_handle->user_conn) {
        return STATE_PORT_INPUT_NULL_POINTER;
    }

    if (g_connected == 1) {
        int rc = xqc_conn_close(ctx.engine, &network_handle->user_conn->cid);
        if (rc) {
            printf("xqc_conn_close error, rc is %d\n", rc);
            //return;
        }
    }
    g_connected = 0;
    event_base_loopbreak(network_handle->eb);

    //wait until previous quic loop exits
    while (g_pre_quic_loop_running == 1) {
        usleep(WAIT_INTERVAL);
        printf("wait previous quic loop to close\r\n");
    }

    sem_destroy(network_handle->conn_sem);
    free(network_handle->conn_sem);
    free(network_handle);
    *handle = NULL;
    printf("done network deinit\r\n");

    return 0;
}

void core_sysdep_rand(uint8_t *output, uint32_t output_len)
{
    uint32_t idx = 0, bytes = 0, rand_num = 0;
    struct timeval time;

    memset(&time, 0, sizeof(struct timeval));
    gettimeofday(&time, NULL);

    srand((unsigned int)(time.tv_sec * 1000 + time.tv_usec / 1000) + rand());

    for (idx = 0; idx < output_len;) {
        if (output_len - idx < 4) {
            bytes = output_len - idx;
        } else {
            bytes = 4;
        }
        rand_num = rand();
        while (bytes-- > 0) {
            output[idx++] = (uint8_t)(rand_num >> bytes * 8);
        }
    }
}

void *core_sysdep_mutex_init(void)
{
    int res = 0;
    pthread_mutex_t *mutex = (pthread_mutex_t *)malloc(sizeof(pthread_mutex_t));
    if (NULL == mutex) {
        return NULL;
    }

    if (0 != (res = pthread_mutex_init(mutex, NULL))) {
        perror("create mutex failed\n");
        free(mutex);
        return NULL;
    }
    /* printf("init mutex: %p\n",mutex); */

    return (void *)mutex;
}

void core_sysdep_mutex_lock(void *mutex)
{
    int res = 0;
    if (mutex != NULL) {
        if (0 != (res = pthread_mutex_lock((pthread_mutex_t *)mutex))) {
            printf("lock mutex failed: - '%s' (%d)\n", strerror(res), res);
        }
    }
}

void core_sysdep_mutex_unlock(void *mutex)
{
    int res = 0;
    if (mutex != NULL) {
        if (0 != (res = pthread_mutex_unlock((pthread_mutex_t *)mutex))) {
            printf("unlock mutex failed - '%s' (%d)\n", strerror(res), res);
        }
    }
}

void core_sysdep_mutex_deinit(void **mutex)
{
    int err_num = 0;
    if (mutex != NULL) {
        /* printf("deinit mutex: %p\n",mutex); */
        if (0 != (err_num = pthread_mutex_destroy(*(pthread_mutex_t **)mutex))) {
            perror("destroy mutex failed\n");
        }
        free(*(pthread_mutex_t **)mutex);
        *mutex = NULL;
    }
}

aiot_sysdep_portfile_t g_aiot_sysdep_portfile = {
    .core_sysdep_malloc = core_sysdep_malloc,
    .core_sysdep_free = core_sysdep_free,
    .core_sysdep_time = core_sysdep_time,
    .core_sysdep_sleep = core_sysdep_sleep,
    .core_sysdep_network_init = core_sysdep_network_init,
    .core_sysdep_network_setopt = core_sysdep_network_setopt,
    .core_sysdep_network_establish = core_sysdep_network_establish,
    .core_sysdep_network_recv = core_sysdep_network_recv,
    .core_sysdep_network_send = core_sysdep_network_send,
    .core_sysdep_network_deinit = core_sysdep_network_deinit,
    .core_sysdep_rand = core_sysdep_rand,
    .core_sysdep_mutex_init = core_sysdep_mutex_init,
    .core_sysdep_mutex_lock = core_sysdep_mutex_lock,
    .core_sysdep_mutex_unlock = core_sysdep_mutex_unlock,
    .core_sysdep_mutex_deinit = core_sysdep_mutex_deinit,
};

